

#ifndef  __LCD20X4_H__
#define  __LCD20X4_H__


#include <stdint.h>
#include "FixedQueue.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class Lcd20x4 {
			protected:
				const static uint8_t STATUS_INIT_1;
				const static uint8_t STATUS_INIT_2;
				const static uint8_t STATUS_INIT_3;
				const static uint8_t STATUS_INIT_4;
				const static uint8_t STATUS_INIT_5;
				const static uint8_t STATUS_INIT_6;
				const static uint8_t STATUS_CHECK_QUEUE;
				const static uint8_t STATUS_WAIT;
				FixedQueue<uint16_t> queue;
				int8_t timerHandler;
				uint8_t status;
				virtual void configurePorts() = 0;
				virtual void setNibble(uint8_t v) = 0;
				virtual void setRS(bool v) = 0;
				virtual void setE(bool v) = 0;
				void sendByte(uint8_t v);
				void sendCommand(uint8_t v);
				void sendData(uint8_t v);
				static uint16_t internalWait();
			public:
				void init();
				void run();
				void queueCommands(uint8_t *v, uint8_t n);
				void queueData(uint8_t *v, uint8_t n);
				void queueSingleCommand(uint8_t v);
				void queueSingleData(uint8_t v);
				void queueString(const char *s);
				void queueLocate(uint8_t x, uint8_t y);
				void queueStringCenter(const char *s, uint8_t y);
				void loadBitmap(uint8_t c, uint8_t *bitmap);
		};
	}
}


#endif  // __LCD20X4_H__
