

#include "Lcd20x4Bar.H"
#include <string.h>


using namespace avelino;
using namespace std;


void Lcd20x4Bar::init() {
	Lcd20x4::init();
	::memset(this->logicalBar, 0, 20);
	::memset(this->physicalBar, 0, 20);
	uint8_t aux[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	this->loadBitmap(0, aux);
	::memset(aux, 0x10, 8);
	this->loadBitmap(1, aux);
	::memset(aux, 0x18, 8);
	this->loadBitmap(2, aux);
	::memset(aux, 0x1C, 8);
	this->loadBitmap(3, aux);
	::memset(aux, 0x1E, 8);
	this->loadBitmap(4, aux);
	::memset(aux, 0x1F, 8);
	this->loadBitmap(5, aux);
}


void Lcd20x4Bar::update() {
	bool insideChange = false;
	uint8_t x;
	for (uint8_t i = 0; i < 20; i++) {
		if (insideChange) {
			if (this->logicalBar[i] == this->physicalBar[i]) {
				this->queueLocate(x, 0);
				this->queueData(&this->logicalBar[x], i - x);
				insideChange = false;
			}
		}
		else {
			if (this->logicalBar[i] != this->physicalBar[i]) {
				x = i;
				insideChange = true;
			}
		}
		this->physicalBar[i] = this->logicalBar[i];
	}
	if (insideChange) {
		this->queueLocate(x, 0);
		this->queueData(&this->physicalBar[x], 20 - x);
	}
}


void Lcd20x4Bar::setV(uint8_t v) {
	if (v > 100)
		v = 100;
	this->v = v;
	uint8_t completeBars = (v / 5);
	uint8_t partialBarValue = (v % 5);
	::memset(this->logicalBar, 0, 20);
	for (uint8_t i = 0; i < completeBars; i++)
		this->logicalBar[i] = 5;
	this->logicalBar[completeBars] = partialBarValue;
	this->update();
}


