/*
 * vim: ts=4 nobackup
 */


#include <stdint.h>
#include "util.H"
#include "Timer.H"
#include "MyLcd20x4Bar.H"
#include "ADCManager.H"


using namespace std;
using namespace avelino;


MyLcd20x4Bar lcd;


int main() {
	Timer::init();
	ADCManager::init();
	lcd.init();
	int8_t adcTimerHandler = Timer::alloc();
	Timer::counter[adcTimerHandler] = TIMER_MS(50);
	while (true) {
		lcd.run();
		if (Timer::counter[adcTimerHandler] == 0) {
			uint16_t analogInput = ADCManager::get(7);
			lcd.setV(analogInput / 10);
			Timer::counter[adcTimerHandler] = TIMER_MS(50);
		}
	}
	return 0;
}
